<?php
//-------------------------------------------------------------------------
// OVIDENTIA http://www.ovidentia.org
// Ovidentia is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//-------------------------------------------------------------------------
/**
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License (GPL)
 * @copyright Copyright (c) 2006 by CANTICO ({@link http://www.cantico.fr})
 */
include_once 'base.php';

require_once $GLOBALS['babInstallPath'] . '/addons/widgets/widgets/lineedit.class.php';


/**
 * Constructs a Widget_RatingEdit.
 *
 * @param string		$id			The item unique id.
 * @return Widget_RatingEdit
 */
function Widget_RatingEdit($id = null)
{
	return new Widget_RatingEdit($id);
}


/**
 * A Widget_RatingEdit is a widget that lets the user enter an rating with stars.
 */
class Widget_RatingEdit extends Widget_LineEdit implements Widget_Displayable_Interface 
{
	

	/**
	 * @param string $id			The item unique id.
	 * @return Widget_LineEdit
	 */
	public function __construct($id = null)
	{
		parent::__construct($id);
		$this->setSize(1);
		
		$this->setMetadata('hints', array(
				widget_translate('Bad'), 
				widget_translate('Poor'), 
				widget_translate('Regular'), 
				widget_translate('Good'), 
				widget_translate('Gorgeous')
		));
	}
	

	public function getClasses()
	{
		$classes = parent::getClasses();
		$classes[] = 'widget-ratingedit';
		return $classes;
	}
	
	
	public function display(Widget_Canvas $canvas)
	{
		$this->setMetadata('readOnly', $this->isDisplayMode());

		$output = $canvas->lineInput(
									$this->getId(),
									$this->getClasses(),
									$this->getFullName(),
									$this->getValue(),
									$this->getSize(),
									$this->getMaxSize(),
									$this->isDisabled(),
									$this->getTitle(),
									$this->getReadOnly(),
									$this->getAutoComplete()
								)
								.$canvas->metadata($this->getId(), $this->getMetadata());
		$output .= $canvas->loadScript($this->getId(), bab_getAddonInfosInstance('widgets')->getTemplatePath().'widgets.ratingedit.jquery.js');
	
		return $output;
	}
}
